package tools.descartes.dql.connector.vsp;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPath;

import tools.descartes.dql.core.engine.util.DQLLogger;

public class VSphereHelper {
	private static final Logger log = DQLLogger.getLogger(VSphereHelper.class
			.getName());

	public static final String CONNECTION_URL_KEY = "vsp.connection.url";
	public static final String CONNECTION_USERNAME_KEY = "vsp.connection.username";
	public static final String CONNECTION_PASSWORD_KEY = "vsp.connection.password";

	public static IWorkspaceRoot getWorkspaceRoot() {
		return ResourcesPlugin.getWorkspace().getRoot();
	}

	public static Properties loadModelProperties(
			final IWorkspaceRoot workspaceRoot, final String modelLocation) {
		final Properties properties = new Properties();
		final IPath workspaceLocation = workspaceRoot.getLocation();
		final IPath workspaceModelLocation = workspaceLocation
				.append(modelLocation);
		final File propertiesFile = workspaceModelLocation.toFile();

		if (!propertiesFile.isFile()) {
			log.error("Specified file in USING not accessible, unable to execute the query further. Aborting.");
			return null;
		}

		try {
			properties.load(new FileInputStream(propertiesFile));
		} catch (final IOException e) {
			log.error("Could not load model instance properties from specified model location in USING clause");
			e.printStackTrace();
		}

		return properties;
	}
}
