/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relative Time Duration Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getDuration <em>Duration</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getTimeModifier <em>Time Modifier</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeDurationClause()
 * @model
 * @generated
 */
public interface RelativeTimeDurationClause extends EObject
{
  /**
   * Returns the value of the '<em><b>Duration</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Duration</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Duration</em>' attribute.
   * @see #setDuration(int)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeDurationClause_Duration()
   * @model
   * @generated
   */
  int getDuration();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getDuration <em>Duration</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Duration</em>' attribute.
   * @see #getDuration()
   * @generated
   */
  void setDuration(int value);

  /**
   * Returns the value of the '<em><b>Time Modifier</b></em>' attribute.
   * The literals are from the enumeration {@link tools.descartes.dql.lang.descartesQL.TimeModifierType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Time Modifier</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Time Modifier</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.TimeModifierType
   * @see #setTimeModifier(TimeModifierType)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeDurationClause_TimeModifier()
   * @model
   * @generated
   */
  TimeModifierType getTimeModifier();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeDurationClause#getTimeModifier <em>Time Modifier</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Time Modifier</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.TimeModifierType
   * @see #getTimeModifier()
   * @generated
   */
  void setTimeModifier(TimeModifierType value);

} // RelativeTimeDurationClause
