/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Connector Time Unit Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl#getCount <em>Count</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.ConnectorTimeUnitClauseImpl#getTimeIndicator <em>Time Indicator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConnectorTimeUnitClauseImpl extends ObservationClauseImpl implements ConnectorTimeUnitClause
{
  /**
   * The default value of the '{@link #getCount() <em>Count</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCount()
   * @generated
   * @ordered
   */
  protected static final int COUNT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getCount() <em>Count</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCount()
   * @generated
   * @ordered
   */
  protected int count = COUNT_EDEFAULT;

  /**
   * The default value of the '{@link #getTimeIndicator() <em>Time Indicator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeIndicator()
   * @generated
   * @ordered
   */
  protected static final String TIME_INDICATOR_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getTimeIndicator() <em>Time Indicator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTimeIndicator()
   * @generated
   * @ordered
   */
  protected String timeIndicator = TIME_INDICATOR_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ConnectorTimeUnitClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.CONNECTOR_TIME_UNIT_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getCount()
  {
    return count;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCount(int newCount)
  {
    int oldCount = count;
    count = newCount;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__COUNT, oldCount, count));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getTimeIndicator()
  {
    return timeIndicator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTimeIndicator(String newTimeIndicator)
  {
    String oldTimeIndicator = timeIndicator;
    timeIndicator = newTimeIndicator;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR, oldTimeIndicator, timeIndicator));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__COUNT:
        return getCount();
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR:
        return getTimeIndicator();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__COUNT:
        setCount((Integer)newValue);
        return;
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR:
        setTimeIndicator((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__COUNT:
        setCount(COUNT_EDEFAULT);
        return;
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR:
        setTimeIndicator(TIME_INDICATOR_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__COUNT:
        return count != COUNT_EDEFAULT;
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE__TIME_INDICATOR:
        return TIME_INDICATOR_EDEFAULT == null ? timeIndicator != null : !TIME_INDICATOR_EDEFAULT.equals(timeIndicator);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (count: ");
    result.append(count);
    result.append(", timeIndicator: ");
    result.append(timeIndicator);
    result.append(')');
    return result.toString();
  }

} //ConnectorTimeUnitClauseImpl
