/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.Currency;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.Penalty;
import tools.descartes.dql.lang.descartesQL.Violation;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Penalty</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.PenaltyImpl#getType <em>Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.PenaltyImpl#getValue <em>Value</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.PenaltyImpl#getCurrency <em>Currency</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.PenaltyImpl#getViolation <em>Violation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PenaltyImpl extends MinimalEObjectImpl.Container implements Penalty
{
  /**
   * The default value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected static final String TYPE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getType()
   * @generated
   * @ordered
   */
  protected String type = TYPE_EDEFAULT;

  /**
   * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected static final double VALUE_EDEFAULT = 0.0;

  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected double value = VALUE_EDEFAULT;

  /**
   * The default value of the '{@link #getCurrency() <em>Currency</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCurrency()
   * @generated
   * @ordered
   */
  protected static final Currency CURRENCY_EDEFAULT = Currency.EURO;

  /**
   * The cached value of the '{@link #getCurrency() <em>Currency</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCurrency()
   * @generated
   * @ordered
   */
  protected Currency currency = CURRENCY_EDEFAULT;

  /**
   * The cached value of the '{@link #getViolation() <em>Violation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getViolation()
   * @generated
   * @ordered
   */
  protected Violation violation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected PenaltyImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.PENALTY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getType()
  {
    return type;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setType(String newType)
  {
    String oldType = type;
    type = newType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.PENALTY__TYPE, oldType, type));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public double getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValue(double newValue)
  {
    double oldValue = value;
    value = newValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.PENALTY__VALUE, oldValue, value));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Currency getCurrency()
  {
    return currency;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCurrency(Currency newCurrency)
  {
    Currency oldCurrency = currency;
    currency = newCurrency == null ? CURRENCY_EDEFAULT : newCurrency;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.PENALTY__CURRENCY, oldCurrency, currency));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Violation getViolation()
  {
    return violation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetViolation(Violation newViolation, NotificationChain msgs)
  {
    Violation oldViolation = violation;
    violation = newViolation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.PENALTY__VIOLATION, oldViolation, newViolation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setViolation(Violation newViolation)
  {
    if (newViolation != violation)
    {
      NotificationChain msgs = null;
      if (violation != null)
        msgs = ((InternalEObject)violation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.PENALTY__VIOLATION, null, msgs);
      if (newViolation != null)
        msgs = ((InternalEObject)newViolation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.PENALTY__VIOLATION, null, msgs);
      msgs = basicSetViolation(newViolation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.PENALTY__VIOLATION, newViolation, newViolation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.PENALTY__VIOLATION:
        return basicSetViolation(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.PENALTY__TYPE:
        return getType();
      case DescartesQLPackage.PENALTY__VALUE:
        return getValue();
      case DescartesQLPackage.PENALTY__CURRENCY:
        return getCurrency();
      case DescartesQLPackage.PENALTY__VIOLATION:
        return getViolation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.PENALTY__TYPE:
        setType((String)newValue);
        return;
      case DescartesQLPackage.PENALTY__VALUE:
        setValue((Double)newValue);
        return;
      case DescartesQLPackage.PENALTY__CURRENCY:
        setCurrency((Currency)newValue);
        return;
      case DescartesQLPackage.PENALTY__VIOLATION:
        setViolation((Violation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.PENALTY__TYPE:
        setType(TYPE_EDEFAULT);
        return;
      case DescartesQLPackage.PENALTY__VALUE:
        setValue(VALUE_EDEFAULT);
        return;
      case DescartesQLPackage.PENALTY__CURRENCY:
        setCurrency(CURRENCY_EDEFAULT);
        return;
      case DescartesQLPackage.PENALTY__VIOLATION:
        setViolation((Violation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.PENALTY__TYPE:
        return TYPE_EDEFAULT == null ? type != null : !TYPE_EDEFAULT.equals(type);
      case DescartesQLPackage.PENALTY__VALUE:
        return value != VALUE_EDEFAULT;
      case DescartesQLPackage.PENALTY__CURRENCY:
        return currency != CURRENCY_EDEFAULT;
      case DescartesQLPackage.PENALTY__VIOLATION:
        return violation != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (type: ");
    result.append(type);
    result.append(", value: ");
    result.append(value);
    result.append(", currency: ");
    result.append(currency);
    result.append(')');
    return result.toString();
  }

} //PenaltyImpl
