/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.repository;

import java.util.Date;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Observation Repository</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getImpacts <em>Impacts</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getObservations <em>Observations</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getStartTimestamp <em>Start Timestamp</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getEndTimestamp <em>End Timestamp</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestObservation <em>Latest Observation</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestImpact <em>Latest Impact</em>}</li>
 * </ul>
 * </p>
 *
 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository()
 * @model
 * @generated
 */
public interface ObservationRepository extends Identfier {
	/**
	 * Returns the value of the '<em><b>Impacts</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.repository.ObservableImpact}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Impacts</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Impacts</em>' containment reference list.
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_Impacts()
	 * @model containment="true"
	 * @generated
	 */
	EList<ObservableImpact> getImpacts();

	/**
	 * Returns the value of the '<em><b>Observations</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.repository.Observation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Observations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Observations</em>' containment reference list.
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_Observations()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<Observation> getObservations();

	/**
	 * Returns the value of the '<em><b>Start Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start Timestamp</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start Timestamp</em>' attribute.
	 * @see #setStartTimestamp(Date)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_StartTimestamp()
	 * @model required="true"
	 * @generated
	 */
	Date getStartTimestamp();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservationRepository#getStartTimestamp <em>Start Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start Timestamp</em>' attribute.
	 * @see #getStartTimestamp()
	 * @generated
	 */
	void setStartTimestamp(Date value);

	/**
	 * Returns the value of the '<em><b>End Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End Timestamp</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End Timestamp</em>' attribute.
	 * @see #setEndTimestamp(Date)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_EndTimestamp()
	 * @model required="true"
	 * @generated
	 */
	Date getEndTimestamp();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservationRepository#getEndTimestamp <em>End Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End Timestamp</em>' attribute.
	 * @see #getEndTimestamp()
	 * @generated
	 */
	void setEndTimestamp(Date value);

	/**
	 * Returns the value of the '<em><b>Latest Observation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Latest Observation</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Latest Observation</em>' reference.
	 * @see #setLatestObservation(Observation)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_LatestObservation()
	 * @model
	 * @generated
	 */
	Observation getLatestObservation();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestObservation <em>Latest Observation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Latest Observation</em>' reference.
	 * @see #getLatestObservation()
	 * @generated
	 */
	void setLatestObservation(Observation value);

	/**
	 * Returns the value of the '<em><b>Latest Impact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Latest Impact</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Latest Impact</em>' reference.
	 * @see #setLatestImpact(ObservableImpact)
	 * @see tools.descartes.dql.models.repository.RepositoryPackage#getObservationRepository_LatestImpact()
	 * @model
	 * @generated
	 */
	ObservableImpact getLatestImpact();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestImpact <em>Latest Impact</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Latest Impact</em>' reference.
	 * @see #getLatestImpact()
	 * @generated
	 */
	void setLatestImpact(ObservableImpact value);

} // ObservationRepository
