# Performance Analysis Visualization

![PAVO Logo](https://se3.informatik.uni-wuerzburg.de/descartes/dql/raw/9adca86e0850228c60a4aa0064fe1837825b59c9/tools.descartes.pavo/logo/logo.jpg)

PAVO was designed as an independent library, mainly matching to DQL, to visualize results given in charts. PAVO already provides many different diagram types, all with their own logic, if they can be displayed or not. PAVO contains an own result type, so other software packages only need to convert their results to that one to make PAVO work. As normally created diagrams are not only used for personal interests, we added an export feature to create several files, which can later be included into e.g. dissertations. PAVO was kept as simple as possible to extend by using the software pattern of Model-View-Controller and the Decorator pattern for the GUI. For the future PAVO can be extended with even more diagram types and shall be included into even more software packages, to simplify them in the idea of Declarative Performance Engineering.
##How to use it 
To use PAVO for your own tool you need to create an instance of [GraphicsEngine](https://se3.informatik.uni-wuerzburg.de/descartes/dql/blob/master/tools.descartes.pavo/src/tools/descartes/pavo/GraphicsEngine.java). Therefore a new constructor is needed, which does basically the same as the two given constructors. Furthermore a new class similar to [TransformEntityMappingToResult](https://se3.informatik.uni-wuerzburg.de/descartes/dql/blob/master/tools.descartes.pavo/src/tools/descartes/pavo/controller/TransformEntityMappingToResult.java) must be created. Here your own result needs to be converted into the PAVO result type. 
##Fragmentation of PAVO
This is the main package for PAVO. Containing all important informations and files. 
These are the packages of PAVO:

* [Core Engine](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo) Main Management of PAVO for all Tabs in the GUI
* [Controller](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/controller) Controllers for each Tab and for the export extension
* [Result Type](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/result) Result Type of PAVO
* [Tests](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/tests) Pavo Tests with DQL and the NOP-Connector
* [Visualization Types](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/types) All different visualization and diagram types of PAVO
* [Utilities](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/util) Little Helpers used in the PAVO code
* [GUI](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/src/tools/descartes/pavo/view) Classes for the graphical user interface of PAVO
 
A complete documentation of the PAVO library can be found in the package [PAVO ReadMePdf](https://se3.informatik.uni-wuerzburg.de/descartes/dql/tree/master/tools.descartes.pavo/PAVO%20ReadMePdf) 

Author: Maximilian König






