/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.pavo.types;

import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.jfree.chart.JFreeChart;

import tools.descartes.pavo.controller.VisualizationController;
import tools.descartes.pavo.view.View;

/**
 * 
 * @author Maximilian König <max.c.koenig@t-online.de>
 * @since 2016
 */
public interface IVisualizationType {
	

	JFreeChart visualize(); 
	
	default JFreeChart visualizeConfidence()
	{
		return visualize();
	}
	
	boolean canVisualize();

	default JPanel getEditViewComponent(VisualizationController c)
	{
		JPanel panel = new JPanel();
		JRadioButton a = View.createConfidence(c.getActionListenerConfidence());
		a.setEnabled(false);
		panel.add(a);
		panel.add(View.createMinMaxMean(c.createActionListenerMin(), c.createActionListenerMax(), c.createActionListenerMean()));
		return panel;
	}
	
	
	


}