# PAVO Types - Chart Types
![PAVO Logo](https://se3.informatik.uni-wuerzburg.de/descartes/dql/raw/9adca86e0850228c60a4aa0064fe1837825b59c9/tools.descartes.pavo/logo/logo.jpg)

In this section all different diagrams types, supported by PAVO are explained in detail. On the one hand side the result types supported and on the other hand side the controls shown by each kind of chart. The standard type, which can be used every time is the bar chart. In figure 3.1 one can see the decision tree of PAVO. It shows which diagram is supported in which case.
##Decision diagram for the choice of chart type
<img src="https://se3.informatik.uni-wuerzburg.de/descartes/dql/raw/215c6b770d43d81247be0a67b932f995ef74c1ce/tools.descartes.pavo/logo/decisiontreepavo.jpg " width="500">


##Confidence Intervals
One additional feature we added to PAVO are the confidence intervals that can be shown. Therefore we added the confidence intervals to the EntityMapping of the result type of DML
 Also for the types of bar chart and line chart there is an active additional radio button, which causes the diagram to switch to the same type but adds these intervals to the plot.
 
##Bar Charts
As already mentioned the main type of diagram is bar chart, which supports all different result types possible. The series are shown in multiple colors. As a special feature for bar charts the user can enable the minimum, maximum and mean value of each series to be shown in the plot as horizontal lines.

##Line Charts
Another standard type of chart is the simple line chart. It also supports the confidence intervals and the radio buttons for minimum, maximum and mean. So there is no big difference compared to a bar chart, except the fact, that a line chart can only be used, if the delivered data series are all marked as continuous and not a single one for the current metric as discrete.

##Difference Chart
To extend the line chart type we added Difference Chart to PAVO. This kind of diagram shall show the user the difference between two series. It is enabled, if the metric has exactly two series. It is not nessecary that both of them are continuous. In the plot the two series are shown as line charts and the space between the two lines is marked in another color. Here no additional features are implemented, neither the minimum, maximum and mean, nor the confidence intervals.

##Scatter Plot
The next standard plot is the Scatter Plot, which is also supported by all different kinds of results. The points in the plot are shown as different geometric forms, depending to the series they belong to, they belong to. Scatter plot can be used to see the spreading around a single point, e.g. the center of both chart axis. As Difference Chart does not support any more features than displaying the values, so does Scatter Plot.

##Box Plot
The last simple type of diagram supported by PAVO is the box plot. Here the program takes all y values of each series together and puts them into a box plot. Box plot is only enabled when there is more than one series of the actual metric, otherwise there would be no additional information gained by using this kind of diagram. As the last few diagram types do not support additional features, box plot also has no extras.

##Bubble Chart
One more complex type of diagram supported by PAVO is Bubble Chart. It is a three dimensional representation of values. It was designed for showing different degrees of free- dom for the results in a diagram. Bubble Chart can only use value results. These are taken as values for the third (the z-axis). The bigger the value the greater the size of the corre- sponding bubble. The other two axis are filled with the DoF-(Degree of Freedom)Values. As one might follow every value result received by e.g. DQL needs to contain the exact same DoF’s. If that is true Bubble Chart is enabled. As additional controls two combo boxes for the selection of the DoF’s for each axis were added. Also another Spinner is shown. Here the user can choose a parameter to enlarge his bubbles, if the values are too low or to big to be shown nice.

##Heat Map
Heat Map is a type of representation pretty similar to Bubble Chart. The only difference is that Heat Maps can only be used for continuous values. So PAVO pnly enables Heat Maps if Bubble Chart is already supported and all values of the different DoF’s only differ by a maximum of 1.0. The additional controls are the exact same, only the Spinner is not existent in the Heat Map button panel.

##Histogram
The graphic rendition of a histogram is also implemented in PAVO. Here the frequency of the x values is shown. As default all values are put into 5 different bins. The user is able to enlarge the number of bins by using the control feature of the histogram part. As a maximum the number of x values is used. If the result received has ”Frequency” as y axis description the y values are used as frequency for the corresponding x value.

##Pie Chart
The last diagram type actually supported by PAVO is a Pie Chart. It is only enabled, if the values of each series can be added to 1 or 100. Another way is by getting multiple value results, which can also be added to 1 or 100.

Author: Maximilian König


